﻿Namespace AppliFrame.SListBases
    Public Class SListBase12

        'ダイアログの親クラス (サンプルライブラリ)
        '☆ このソースコードは､ 共用ライブラリを作成するときに参考にしてください。
        '☆ このソースコードの解読は､ 許諾されています。

        'コンストラクタ
        Sub New()
            MyBase.New()
            ' この呼び出しは、Windows フォーム デザイナで必要です。
            InitializeComponent()

            ' InitializeComponent() 呼び出しの後で初期化を追加します。

        End Sub 'New

        'ItemsList の横幅を文字数で表した値。
        Protected Property CharsInItemsList() As Integer
            Get
                Return (Me.Width - 15) \ 9 '----------
            End Get
            Set(ByVal Value As Integer)
                If Value < 1 Then
                    'エラーの場合の処理
                Else
                    Me.Width = 9 * Value + 15
                End If
            End Set
        End Property 'CharsInItemsList

        'ItemsList の縦の高さを行数で表した値。
        Protected Property RowsInItemsList() As Integer
            Get
                Return (Me.Height - 96) \ 16 '----------
            End Get
            Set(ByVal Value As Integer)
                If Value < 1 Then
                    'エラーの場合の処理
                Else
                    Me.Height = 16 * Value + 96
                End If
            End Set
        End Property 'RowsInItemsList

        'SList からの復帰値。
        Public SListReturn As Object = Nothing

        'SListBase_Activated イベントハンドラ。
        Protected Overridable Sub SListBase_Activated(ByVal eventSender As Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Activated
            Debug.WriteLine("SListBase_Activated")
            '
            On Error Resume Next
            Me.ItemsList.Focus()
        End Sub 'SListBase_Activated

        'SListBase_Load イベントハンドラ。
        Protected Overridable Sub SListBase_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
            Debug.WriteLine("SListBase_Load")
            Me.ItemsList.Items.Clear()
            Me.ItemsList.Items.Add("Item1")
            Me.ItemsList.Items.Add("Item2")
            Me.ItemsList.Items.Add("Item3")
        End Sub 'SListBase_Load

        'OkButton_Click イベントハンドラ。
        Protected Overridable Sub OkButton_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles OkButton.Click
            Debug.WriteLine("OkButton_Click")
            Me.SListReturn = ItemsList.Text.Trim()
        End Sub 'OkButton_Click

        'OkButton_MouseUp イベントハンドラ。
        Protected Overridable Sub OkButton_MouseUp(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.MouseEventArgs) Handles OkButton.MouseUp
            Debug.WriteLine("OkButton_MouseUp")
            On Error Resume Next
            Me.ItemsList.Focus()
        End Sub 'OkButton_MouseUp

        'EscButton_MouseUp イベントハンドラ。
        Protected Overridable Sub EscButton_MouseUp(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.MouseEventArgs) Handles EscButton.MouseUp
            Debug.WriteLine("EscButton_MouseUp")
            On Error Resume Next
            Me.ItemsList.Focus()
        End Sub 'EscButton_MouseUp

        'ItemsList_DoubleClick イベントハンドラ。
        Protected Overridable Sub ItemsList_DoubleClick(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles ItemsList.DoubleClick
            Debug.WriteLine("ItemsList_DoubleClick")
            Me.DialogResult = System.Windows.Forms.DialogResult.OK
            OkButton_Click(eventSender, Nothing)
        End Sub 'ItemsList_DoubleClick

    End Class
End Namespace 'AppliFrame.SListBases
