﻿Option Strict On
Option Explicit On
'☆ このソースコードの解読は､ 許諾されています。
'Imports 受注業務.受注業務FormBase '(ii_xxxx 参照用)
Imports AppliTech.WorkFrame
Imports VB = Microsoft.VisualBasic
#If LocalOrOp OrElse Not CentralOrOp Then
Imports System.Windows.Forms
#End If

Friend Class 商品コード

    'データ項目部品 ｢商品コード｣

    'セントラルとローカル間､ および複数のフックメソッド間の連絡域
    Friend Interface Common
#If CentralOrOp OrElse Not LocalOrOp Then
        Property 商品レコード() As 商品Table '★ 親クラスの型にはしない。
#End If
    End Interface 'Common

    '#Region "ローカルピース､ セントラルピース共通に用いるフックメソッドなど"
    '    'なし
    '#End Region 'ローカルピース､ セントラルピース共通に用いるフックメソッドなど

#Region "ローカルピースに配置するフックメソッドなど"
#If LocalOrOp OrElse Not CentralOrOp Then

    '商品コードの入力候補一覧を表示する。
    Friend Function 選択リスト(ByVal fB As FormBase, ByVal iB_商品コード As ItemBase) As String
        Dim 商品コード選択リスト As Jutyu.AppliFrame.SListBases.SListBase12 = New Dlg商品コード(fB, iB_商品コード)
        '
        Dim wk_DialogResult As DialogResult = 商品コード選択リスト.ShowDialog(fB.myForm)
        If Not (fB.sListCom Is Nothing) Then
            Return CType(fB.sListCom, String) '----------
        Else
            Return Nothing '----------
        End If
    End Function '選択リスト

    'エラーメッセージを表示する (Response)。
    Friend Function 応答表示(ByVal fB As FormBase, ByVal Cd_Error As Integer) As Boolean
        If Cd_Error <> 0 Then
            Dim メッセージ As String
            Select Case Cd_Error
                Case 300
                    メッセージ = "商品コードに誤りがあります。"
                Case Else
                    メッセージ = "登録されていないメッセージ " + Cd_Error.ToString() + " です。"
            End Select
            fB.Beep()
            fB.StatusOut(メッセージ, System.Drawing.Color.Red)
        End If
        Return True
    End Function '応答表示

#End If
#End Region 'ローカルピースに配置するフックメソッドなど

#Region "セントラルピースに配置するフックメソッドなど"
#If CentralOrOp OrElse Not LocalOrOp Then

    '◆ Jutyu0, Jutyu1 と異なり､ Jutyu2 では､ SList のデータをセントラルとローカル間で転送するように変更しました。
    Friend Function 中央局処理(ByVal fB As FormBase, ByVal Rm_Object As Object) As Object
        Select Case CType(Rm_Object, String)
            Case "ForSList"
                Dim co As Common = CType(fB.getCommon(), Common)
                Dim SyohnCdObj As Serializables.SyohnCd = New Serializables.SyohnCd(co.商品レコード.RecordCount)
                '
                co.商品レコード.SetCursorForAllRecords()
                Dim wk_Return As Integer = co.商品レコード.ReadSequential()
                Dim I As Integer = 0
                While wk_Return = 0
                    SyohnCdObj.商品コード(I) = co.商品レコード.商品コード
                    SyohnCdObj.商品名称(I) = co.商品レコード.商品名称
                    SyohnCdObj.商品単価(I) = co.商品レコード.商品単価
                    wk_Return = co.商品レコード.ReadSequential()
                    I += 1
                End While
                '
                Return SyohnCdObj '----------
            Case Else
                Return Nothing '----------
        End Select
    End Function

    '商品マスタテーブルをオープンする。
    Friend Function 開設現地後(ByVal fB As FormBase) As Boolean
        Dim co As Common = CType(fB.getCommon(), Common)
        Dim Path As String = FormBase.GetAppSetting("Jutyu2.DataDirectory")
        If Path Is Nothing Then Path = fB.MyBinPath
        co.商品レコード = New 商品Table(Path + "Syohn.txt") '[20080825][追加]
        '
        Dim 復帰コード As Integer = co.商品レコード.Connect()
        Return ItemBase.BEGINPRGALCL_Allow '----------
    End Function '開設現地後

    '商品コードが入力された場合に、そのチェックを行う。
    Friend Function 入力チェック(ByVal fB As FormBase, ByVal 商品コード As String, ByVal 前_商品コード As String, ByVal De_Index As Integer) As Integer
        If 商品コード = String.Empty Then '商品コードの空入力。
            Return 300 '---------- 'エラーコード 300。
        Else
            Dim co As Common = CType(fB.getCommon(), Common)
            Dim 復帰コード As Integer = co.商品レコード.SelectEqual(商品コード)
            If 復帰コード = 0 Then '商品コードが見つかった。
                If Not fB.RecalcMode AndAlso 前_商品コード <> 商品コード Then
                    '手入力フラグをクリアする
                    fB.setValue(ii_手入力, De_Index, String.Empty)
                End If
                Return ItemBase.CHECK_OK '---------- '正常終了。
            Else '商品コードが見つからない。
                Return 300 '---------- 'エラーコード 300。
            End If
        End If
    End Function '入力チェック

    '商品マスタテーブルをクローズする。
    Friend Function 閉鎖現地前(ByVal fB As FormBase) As Boolean
        Dim co As Common = CType(fB.getCommon(), Common)
        co.商品レコード.Disconnect()
        Return ItemBase.CLOSEBLCL_Allow '----------
    End Function '閉鎖現地前

#End If
#End Region 'セントラルピースに配置するフックメソッドなど

End Class '商品コード
