﻿Option Strict On
Option Explicit On
'☆ このソースコードの解読は､ 許諾されています。
Imports AppliTech.WorkFrame
Imports System
Imports VB = Microsoft.VisualBasic
#If LocalOrOp OrElse Not CentralOrOp Then
Imports System.Windows.Forms
#End If

Friend Class 受注日付

    'データ項目部品 ｢受注日付｣

    'セントラルとローカル間､ および複数のフックメソッド間の連絡域
    Friend Interface Common
        ReadOnly Property 有効日付() As Date
        Property 追加モードに移行直後() As Boolean
    End Interface 'Common

#Region "ローカルピース､ セントラルピース共通に用いるフックメソッドなど"

    Private ReadOnly クリア表示 As String = "　  -  -  " '先頭は全角の空白

    '受注日付の初期値を設定する。
    Friend Function 初期値双方(ByVal fB As FormBase, ByVal 受注日付 As String, ByVal 詳_受注日付 As ItemBase) As String
        Dim co As Common = CType(fB.getCommon(), Common)
        If co.追加モードに移行直後 OrElse 受注日付 = String.Empty OrElse 受注日付.Trim() = クリア表示.Trim() Then
            Return FormBase.FormatDate(VB.DateAndTime.Today, 詳_受注日付.FormatChr) '---------- '本日の日付。
        Else
            Return FormBase.FormatDate(DateTime.Parse(受注日付), 詳_受注日付.FormatChr) '---------- '前の伝票の日付。
        End If
    End Function '初期値双方

    '受注日付が入力された場合に、そのチェックを行う。
    Friend Function 入力チェック双方(ByVal fB As FormBase, ByVal 受注日付 As String) As Integer
        If 受注日付 = クリア表示 Then
            Return ItemBase.CHECK_OK '---------- '正常終了。
        ElseIf fB.IsDateString(受注日付) Then
            Dim co As Common = CType(fB.getCommon(), Common)
            If FormBase.CVDate(受注日付) < co.有効日付 Then
                Return 101 '---------- 'エラーコード 101。
            Else
                Return ItemBase.CHECK_OK '---------- '正常終了。
            End If
        Else
            Return 100 '---------- 'エラーコード 100。
        End If
    End Function '入力チェック双方

#End Region 'ローカルピース､ セントラルピース共通に用いるフックメソッドなど

#Region "ローカルピースに配置するフックメソッドなど"
#If LocalOrOp OrElse Not CentralOrOp Then

    'カーソルを年のところではなく日のところに進ませる。
    Friend Function スキップ(ByVal 受注日付 As String, ByVal 項_受注日付 As System.Windows.Forms.Control) As Boolean
        If 受注日付 <> クリア表示 Then
            CType(項_受注日付, TextBox).SelectionStart = 7 '平yy-mm-dd の dd のところ。
        End If
        Return ItemBase.SKIP_False '----------
    End Function 'スキップ

    'エラーメッセージを表示する (Response)。
    Friend Function 応答表示(ByVal fB As FormBase, ByVal Cd_Error As Integer, ByVal iB_受注日付 As ItemBase) As Boolean
        If Cd_Error <> 0 Then
            Dim メッセージ As String
            Select Case Cd_Error
                Case 100
                    メッセージ = "日付に誤りがあります。"
                Case 101
                    Dim co As Common = CType(fB.getCommon(), Common)
                    メッセージ = FormBase.FormatDate(co.有効日付, iB_受注日付.FormatChr) + " 以降の日付にしてください。"
                Case Else
                    メッセージ = "登録されていないメッセージ " + Cd_Error.ToString() + " です。"
            End Select
            fB.Beep()
            fB.StatusOut(メッセージ, System.Drawing.Color.Red)
        End If
        Return True
    End Function '応答表示

    '日付の入力候補一覧を表示する。
    Friend Function 選択リスト(ByVal fB As FormBase, ByVal IB_This As ItemBase) As String
        Dim 日付選択リスト As Jutyu.AppliFrame.SListBases.SListCalendar18 = New Jutyu.AppliFrame.SListBases.SListCalendar18
        '
        Dim wk_DialogResult As DialogResult = 日付選択リスト.ShowDialog(fB.myForm)
        If wk_DialogResult = DialogResult.OK Then
            Return FormBase.FormatDate(CType(日付選択リスト.SListReturn, Date), IB_This.FormatChr) '----------
        Else
            Return Nothing '----------
        End If
    End Function '選択リスト

    '受注日付の値を伝票の入力後に設定する。
    Friend Function 後処理(ByVal fB As FormBase, ByVal 受注日付 As String) As String
        Dim co As Common = CType(fB.getCommon(), Common)
        co.追加モードに移行直後 = False
        Return 受注日付 '----------
    End Function '後処理

#End If
#End Region 'ローカルピースに配置するフックメソッドなど

    '#Region "セントラルピースに配置するフックメソッドなど"
    '#If CentralOrOp OrElse Not LocalOrOp Then
    '    'なし
    '#End If
    '#End Region 'セントラルピースに配置するフックメソッドなど

End Class '受注日付
