﻿Option Strict On
Option Explicit On
'☆ このソースコードの解読は､ 許諾されています。
'Imports AppliTech.Remoting
'Imports System
'Imports System.Diagnostics
'Imports System.Runtime.Remoting
'Imports System.Runtime.Remoting.Channels
'Imports System.Collections

'このモジュールの変更履歴:
'
'V8.60.25.21 における変更。
'  - 運用コマンド (list, reject, kill all, help) を追加しました。
'  - セキュリティ保護に対応しました。
'  - TcpChannel 経由のリモート処理に対応しました。
'  - アプリケーション構成ファイルでの設定に対応しました。
'    ● このために､ プロジェクトの参照設定として System.Configuration を追加することが必要になりました。
'  - コマンド解析時の文字列処理を分かりやすくしました。
'  - Sweep 処理を Communicator に移動し､ このモジュールからは削除しました。

Namespace CentralMain
    Public Class CentralMain 'Shared Class
        Implements AppliTech.Remoting.ICommHandler '追加 V8.60.25.21

        '追加 V8.60.25.21 ここから
        'リモート処理の方式を決定します。
        '置換え候補 Private MyURI As System.Uri = New System.Uri("tcp://localhost:9090/REMOTING")
        Private MyURI As System.Uri = New System.Uri("http://localhost:8080/REMOTING")
        Private EnsureSecurity As Boolean = False
        '追加 V8.60.25.21 ここまで

        'リモートオブジェクトを起動して､ 存続させる。

        Private ActiveMax As Integer = 999 'アクティブセッション ID の最大値 (同時アクティブセッション数の最大値 - 1) '変更 V8.60.25.21 Shared 除去
        Friend Shared comm As AppliTech.Remoting.Communicator 'V8.60.25.21 Friend に変更

        '削除 V8.60.25.21 Private SweepTimer As System.Timers.Timer 'Communicatorへ移行

        Private ReadOnly COMMAND_DELIMITER As Char() = {" "c} '追加 V8.60.25.21

        'V8.60.25.21 インスタンスを生成して動作するよう変更
        Public Shared Sub Main()
            Dim myInstance As CentralMain = New CentralMain()
            myInstance.MainLoop()
        End Sub 'Main

        'V8.60.25.21 インスタンス保護用 プライベートコンストラクタ
        Private Sub New()
            MyBase.New()
            GetConfiguration() '追加 V8.60.25.21
            'ここから先は､ もとの Main メソッドから移動してきた部分 (ループより前の部分)
            '構成ファイルではなく､ プログラムで。RemotingConfiguration.Configure("MyServer.exe.config")
            Try 'V8.60.25.21 try 節の中身はすべて交換
                Dim properties As System.Collections.IDictionary = New System.Collections.Hashtable()
                properties.Add("port", MyURI.Port) '追加 V8.60.25.21 ポート番号を指定
                'V8.60.25.21 Channel の構築を変更 Tcp か Http か選択
                Dim myChannel As System.Runtime.Remoting.Channels.IChannel = Nothing
                If MyURI.Scheme.Equals("tcp") Then
                    myChannel = New System.Runtime.Remoting.Channels.Tcp.TcpServerChannel(properties, Nothing)
                ElseIf MyURI.Scheme.Equals("http") OrElse MyURI.Scheme.Equals("https") Then
                    myChannel = New System.Runtime.Remoting.Channels.Http.HttpServerChannel(properties, Nothing)
                Else
                End If
                System.Runtime.Remoting.Channels.ChannelServices.RegisterChannel(myChannel, EnsureSecurity) 'V8.60.25.21 ensureSecurity使用
            Catch ex As System.Exception
                System.Diagnostics.Debug.WriteLine(ex.Message)
                Stop
            End Try
            '
            '単一の CommunicatorForDebug オブジェクトをコンストラクトする指定。
            'クライアントは､ すべてこのインスタンスを用いる。
            comm = New AppliTech.Remoting.Communicator()
            System.Console.WriteLine("Communicator starts up. My Id: {0}", Me.GetHashCode()) '追加 V8.60.25.21
            comm.AddCallBackHandler(Me) '追加 V8.60.25.21

            Dim objectURI As String = MyURI.GetComponents(System.UriComponents.Path, System.UriFormat.UriEscaped) '追加 V8.60.25.21
            Dim oref As System.Runtime.Remoting.ObjRef = System.Runtime.Remoting.RemotingServices.Marshal(comm, objectURI) 'V8.60.25.21 第2パラメタを変更

            '[20060703][削除] ここから (Communicator へ移行)
            'SweepTimer = New System.Timers.Timer
            'SweepTimer.Interval = 1000 '単位 1 ミリ秒
            'AddHandler SweepTimer.Elapsed, AddressOf TimerEvent
            'SweepTimer.Enabled = True
            '[20060703][削除] ここまで

            System.Console.WriteLine("◎ サーバが起動されました。(" + System.DateTime.Now.ToString("yyyy年MM月dd日HH時mm分ss秒") + ")")
            '追加 V8.60.25.21 ここから
            System.Console.ForegroundColor = System.ConsoleColor.Green
            System.Console.Write(MyURI)
            System.Console.ResetColor()
            System.Console.WriteLine(" で待ち受けます。")
            comm.SetActiveMax(ActiveMax)
            '追加 V8.60.25.21 ここまで
        End Sub 'New

        'V8.60.25.21 Main から MainLoop へループ部分の内容を移動
        Private Sub MainLoop()
            While True
                '削除 V8.60.25.21 ここから
                '削除 If ActiveMax = 0 Then
                '削除     System.Console.WriteLine("""Exit"" および ""Kill"" というコマンドがあります。")
                '削除 Else
                '削除     System.Console.WriteLine("""Exit"" および ""Kill 識別番号"" というコマンドがあります。")
                '削除 End If
                '削除 V8.60.25.21 ここまで
                PromptCommand() '追加 V8.60.25.21
                Dim userInput As String = System.Console.ReadLine()
                Dim userInputs As String() = userInput.Split(COMMAND_DELIMITER) '追加 V8.60.25.21
                Dim commandName As String = userInputs(0).ToLower() '追加 V8.60.25.21
                Dim paramCount As Integer = userInputs.Length - 1 '追加 V8.60.25.21
                '
                'コマンド解析 全面書き換え V8.60.25.21
                If commandName.Equals("max") Then
                    If paramCount = 0 Then
                        ShowMessage("識別番号の最大値は {0} です。", ActiveMax)
                        Continue While
                    ElseIf paramCount = 1 Then
                        Dim wk_max As Integer = -1
                        If Integer.TryParse(userInputs(1), wk_max) And wk_max >= 0 Then
                            If wk_max < ActiveMax Then
                                ShowInputError("識別番号の最大値 {0} を下げることはできません。", ActiveMax)
                                Continue While
                            Else
                                ActiveMax = wk_max
                                comm.SetActiveMax(ActiveMax)
                                ShowMessage("識別番号の最大値を {0} にしました。", ActiveMax)
                                Continue While
                            End If
                        End If
                    End If
                    ShowInputError("タイプインされた MAX コマンドのパラメタに誤りがあります。")

                ElseIf commandName.Equals("exit") Then
                    Dim ActiveCount As Integer = comm.GetAllSessionId().Length 'comm.GetActiveCount() 'V8.60.25.23 [修正]
                    If ActiveCount = 0 Then
                        AcceptCommand(commandName)
                        Exit While '-----
                    Else
                        System.Console.WriteLine("アクティブなセッションが {0} 個あるので EXIT は有効に働きません。", ActiveCount)
                    End If
                ElseIf commandName.Equals("kill") Then
                    If paramCount = 0 AndAlso ActiveMax = 0 Then
                        AcceptCommand(commandName)
                        comm.DisposeInstance(0)
                        Continue While
                    ElseIf paramCount = 1 Then
                        If (userInputs(1).ToLower().Equals("all")) Then
                            AcceptCommand(commandName)
                            Dim res As Boolean = AskYesNo("すべてのセッションを強制終了します。よろしいですか? (y/n)")
                            If res Then
                                AcceptCommand(commandName)
                                comm.DisposeAllInstances()
                            Else
                                ShowMessage("KILL コマンドは取り消されました。")
                            End If
                            Continue While
                        Else
                            Dim wk_id As Integer = -1
                            If Integer.TryParse(userInputs(1), wk_id) AndAlso wk_id >= 0 Then
                                If wk_id <= ActiveMax Then
                                    If comm.IsActive(wk_id) Then
                                        AcceptCommand(commandName)
                                        comm.DisposeInstance(0)
                                        Continue While
                                    Else
                                        ShowInputError("指定の識別番号はアクティブでないので KILL できません。")
                                    End If
                                Else
                                    ShowInputError("KILL コマンドのパラメタは､ 識別番号の最大値 {0} 以下でなければなりません。", ActiveMax)
                                End If
                            End If
                        End If
                    End If
                    ShowInputError("タイプインされた KILL コマンドのパラメタに誤りがあります。")
                ElseIf commandName.Equals("reject") Then
                    If paramCount = 0 Then
                        If comm.IsRejectMode() Then
                            ShowMessage("現在 REJECT モードです。")
                        Else
                            ShowMessage("現在 REJECT モードではありません。")
                        End If
                        Continue While
                    ElseIf paramCount = 1 Then
                        Dim param As String = userInputs(1).ToLower()
                        If param.Equals("on") Then
                            If comm.IsRejectMode() Then
                                ShowMessage("すでに REJECT モードです。")
                            Else
                                AcceptCommand(commandName)
                                comm.SetRejectMode(True)
                            End If
                            Continue While
                        ElseIf param.Equals("off") Then
                            If comm.IsRejectMode() Then
                                AcceptCommand(commandName)
                                comm.SetRejectMode(False)
                            Else
                                ShowMessage("現在 REJECT モードではありません。")
                            End If
                            Continue While
                        End If
                    End If
                    ShowInputError("タイプインされた REJECT コマンドのパラメタに誤りがあります。")
                ElseIf commandName.Equals("list") Then
                    If paramCount = 0 Then
                        Dim idArray As Integer() = comm.GetAllSessionId()
                        ListHeader()
                        For Each id As Integer In idArray
                            ShowSession(id)
                        Next
                        ShowMessage("アクティブなセッションの数は {0} です。", idArray.Length)
                        Continue While
                    Else
                        Dim wk_id As Integer = -1
                        If Integer.TryParse(userInputs(1), wk_id) AndAlso wk_id >= 0 Then
                            If wk_id <= ActiveMax Then
                                If comm.IsActive(wk_id) Then
                                    ListHeader()
                                    ShowSession(wk_id)
                                    Continue While
                                Else
                                    ShowInputError("指定の識別番号はアクティブでないので表示できません。")
                                End If
                            Else
                                ShowInputError("LIST コマンドのパラメタは､ 識別番号の最大値 {0} 以下でなければなりません。", ActiveMax)
                            End If
                        End If
                    End If
                ElseIf commandName.Equals("timer") Then
                    ShowMessage("現在の生存監視間隔は {0} 分です。", comm.GetWatchAliveInterval())
                ElseIf commandName.Equals("autokill") Then
                    If paramCount = 0 Then
                        If comm.IsAutoKillMode() Then
                            ShowMessage("現在 AUTOKILL モードです。")
                        Else
                            ShowMessage("現在 AUTOKILL モードではありません。")
                        End If
                        Continue While
                    ElseIf paramCount = 1 Then
                        Dim param As String = userInputs(1).ToLower()
                        If param.Equals("on") Then
                            If comm.IsAutoKillMode() Then
                                ShowMessage("すでに AUTOKILL モードです。")
                            Else
                                AcceptCommand(commandName)
                                comm.SetAutoKillMode(True)
                            End If
                            Continue While
                        ElseIf param.Equals("off") Then
                            If comm.IsAutoKillMode() Then
                                AcceptCommand(commandName)
                                comm.SetAutoKillMode(False)
                            Else
                                ShowMessage("現在 AUTOKILL モードではありません。")
                            End If
                            Continue While
                        End If
                    End If
                    ShowInputError("タイプインされた AUTOKILL コマンドのパラメタに誤りがあります。")
                ElseIf commandName.Equals("help") Then
                    System.Console.WriteLine("[ コマンド一覧 ]")
                    System.Console.WriteLine(" AUTOKILL ON  :自動強制終了モードにします。")
                    System.Console.WriteLine(" AUTOKILL OFF :自動強制終了モードを解除します。")
                    System.Console.WriteLine(" EXIT         :サーバを終了します。")
                    System.Console.WriteLine(" LIST 数字    :数字で指定したセッションの情報を表示します。")
                    System.Console.WriteLine(" LIST         :すべてのセッションの情報を表示します。")
                    System.Console.WriteLine(" KILL 数字    :数字で指定したセッションを強制終了させます。")
                    System.Console.WriteLine(" KILL ALL     :すべてのセッションを強制終了させます。")
                    System.Console.WriteLine(" MAX          :最大セッション数を表示します。")
                    System.Console.WriteLine(" MAX  数字    :最大セッション数を指定します。")
                    System.Console.WriteLine(" REJECT ON    :アプリ起動を不許可にします。")
                    System.Console.WriteLine(" REJECT OFF   :アプリ起動を許可するようにします。")
                    System.Console.WriteLine(" TIMER        :生存監視タイマの監視間隔を表示します。")
                    System.Console.WriteLine(" HELP         :この説明を表示します。")
                    '追加 V8.60.25.21ここまで
                    '削除 ElseIf userInput.ToLower() = "javadotnet" Then
                    '削除     System.Console.WriteLine(userInput + " コマンドを受け取りました。")
                    '削除     comm.SetJavaDotNet(True)
                Else
                    System.Console.WriteLine("タイプインされたコマンドは､ 無効です。")
                End If
            End While
        End Sub 'MainLoop

        '追加 V8.60.25.21 ここから
        'アプリケーション設定を構成ファイルなどから取得します。
        '● この機能のために､ プロジェクトの参照設定として System.Configuration を追加することが必要になりました。
        Private Sub GetConfiguration()
            'リモート処理サーバの URL を取得します
            Dim sg_serverUrl As String = System.Configuration.ConfigurationManager.AppSettings("CentralServerURL")
            If Not (sg_serverUrl Is Nothing) Then
                MyURI = New System.Uri(sg_serverUrl)
                Me.ShowMessage("Config より サーバ URL を {0} に設定しました。", sg_serverUrl) 'V8.60.25.23 [追加]
            End If
            'セキュリティ有無を取得します。
            Dim sg_ensureSecurity As String = System.Configuration.ConfigurationManager.AppSettings("EnsureSecurity")
            If Not (sg_ensureSecurity Is Nothing) Then
                EnsureSecurity = (String.Compare(sg_ensureSecurity, "True", True) = 0)
                Me.ShowMessage("Config より セキュリティ使用を {0} に設定しました。", EnsureSecurity) 'V8.60.25.23 [追加]
            End If
            'ActiveMax を取得します。
            Dim sg_activeMax As String = System.Configuration.ConfigurationManager.AppSettings("ActiveMax") 'V8.60.25.23 [追加]
            If Not (sg_activeMax Is Nothing) AndAlso Integer.TryParse(sg_activeMax, ActiveMax) Then 'V8.60.25.23 [追加]
                Me.ShowMessage("Config より ActiveMax を {0} に設定しました。", ActiveMax) 'V8.60.25.23 [追加]
            End If 'V8.60.25.23 [追加]
        End Sub

        '追加 V8.60.25.21 ここまで

        '削除 V8.60.25.21 ここから (この機能はCommunicator へ移動)
        'Private Shared Sub TimerEvent(ByVal eventSender As System.Object, ByVal eventArgs As System.Timers.ElapsedEventArgs)
        '    comm.Sweep()
        'End Sub 'TimerEvent
        '削除 V8.60.25.21 ここまで

        Friend Shared Function Mid2(ByVal pm_String As String, ByVal pm_Pos As Integer) As String
            If pm_Pos > pm_String.Length Then
                Return String.Empty '----------
            Else
                Return pm_String.Substring(pm_Pos - 1) '----------
            End If
        End Function 'Mid2

        '追加 V8.60.25.21 ここから
        Public Sub AssemblyLoaded(ByVal loadedAssemblyName As String) Implements AppliTech.Remoting.ICommHandler.AssemblyLoaded
            If System.Console.CursorLeft <> 0 Then System.Console.WriteLine() '追加 V8.60.25.21
            System.Console.ForegroundColor = System.ConsoleColor.DarkGray '追加 V8.60.25.21
            System.Console.WriteLine("アセンブリ ""{0}"" をロードしました。", loadedAssemblyName)
            System.Console.ResetColor() '追加 V8.60.25.21
            PromptAfterOneSecond() '追加 V8.60.25.21
        End Sub 'AssemblyLoaded

        Public Sub AssemblyUnloaded(ByVal unloadedAssemblyName As String) Implements AppliTech.Remoting.ICommHandler.AssemblyUnloaded
            If System.Console.CursorLeft <> 0 Then System.Console.WriteLine() '追加 V8.60.25.21
            System.Console.ForegroundColor = System.ConsoleColor.DarkGray '追加 V8.60.25.21
            System.Console.WriteLine("アセンブリ ""{0}"" をアンロードしました。", unloadedAssemblyName)
            System.Console.ResetColor() '追加 V8.60.25.21
            PromptAfterOneSecond() '追加 V8.60.25.21
        End Sub 'AssemblyUnloaded

        Public Sub ExceptionOccured(ByVal sessionId As Integer, ByVal occuredException As System.Exception) Implements AppliTech.Remoting.ICommHandler.ExceptionOccured
            If System.Console.CursorLeft <> 0 Then System.Console.WriteLine() '追加 V8.60.25.21
            System.Console.ForegroundColor = System.ConsoleColor.Red '追加 V8.60.25.21
            Dim userName As String = comm.GetCurrentUserName()
            System.Console.WriteLine("{0}:例外が発生しました。({1})", sessionId, userName)
            System.Console.WriteLine(occuredException.ToString())
            System.Console.ResetColor() '追加 V8.60.25.21
            PromptAfterOneSecond() '追加 V8.60.25.21
        End Sub 'ExceptionOccured

        Public Sub FormBaseCreated(ByVal sessionId As Integer) Implements AppliTech.Remoting.ICommHandler.FormBaseCreated
            If System.Console.CursorLeft <> 0 Then System.Console.WriteLine() '追加 V8.60.25.21
            System.Console.ForegroundColor = System.ConsoleColor.DarkGreen '追加 V8.60.25.21
            Dim userName As String = comm.GetUserName(sessionId)
            Dim className As String = comm.GetFormBaseClassName(sessionId)
            System.Console.WriteLine("{0}: クラス ""{1}"" のインスタンスを作成しました。({2})", sessionId, className, userName)
            System.Console.ResetColor() '追加 V8.60.25.21
            PromptAfterOneSecond() '追加 V8.60.25.21
        End Sub 'FormBaseCreated

        Public Sub FormBaseDestroyed(ByVal sessionId As Integer, ByVal fBName As String) Implements AppliTech.Remoting.ICommHandler.FormBaseDestroyed
            If System.Console.CursorLeft <> 0 Then System.Console.WriteLine() '追加 V8.60.25.21
            System.Console.ForegroundColor = System.ConsoleColor.DarkGreen '追加 V8.60.25.21
            Dim userName As String = comm.GetUserName(sessionId)
            System.Console.WriteLine("{0}: クラス ""{1}"" のインスタンスを破棄します。({2})", sessionId, fBName, userName)
            System.Console.ResetColor() '追加 V8.60.25.21
            PromptAfterOneSecond() '追加 V8.60.25.21
        End Sub 'FormBaseDestroyed

        'コマンド受領を表示します。
        Private Shared Sub AcceptCommand(ByVal cmdName As String)
            System.Console.Out.WriteLine("{0} コマンドを受け取りました。", cmdName)
        End Sub 'AcceptCommand

        'コンソール入力で Y/N を訪ねます。Y なら True, N なら False を返します。
        'Y YES N NO のいずれかを受け入れます。
        Private Shared Function AskYesNo(ByVal promptMessage As String) As Boolean
            System.Console.Out.Write(promptMessage)
            Do
                Dim userInput As String = System.Console.In.ReadLine()
                Dim lowUserInput As String = userInput.ToLower()
                If lowUserInput.Equals("y") OrElse lowUserInput.Equals("yes") Then
                    Return True
                End If
                If lowUserInput.Equals("n") OrElse lowUserInput.Equals("no") Then
                    Return True
                End If
                System.Console.Error.WriteLine("Y または N を入力してください。")
            Loop
        End Function 'AskYesNo

        'コンソールに FormBase 情報を表示します。
        Private Sub ShowSession(ByVal sessionId As Integer)
            Dim userName As String = comm.GetUserName(sessionId)
            Dim fBName As String = comm.GetFormBaseClassName(sessionId)
            '置換 V8.60.25.21 ここから
            Dim lastDotOfFB As Integer = fBName.LastIndexOf("."c)
            If lastDotOfFB >= 0 AndAlso lastDotOfFB < fBName.Length - 1 Then
                fBName = fBName.Substring(lastDotOfFB + 1)
            End If
            If fBName.Length > 8 AndAlso fBName.ToLower().EndsWith("formbase") Then
                fBName = fBName.Substring(0, fBName.Length - 8)
            End If
            '置換 V8.60.25.21 ここまで
            '追加 V8.60.25.21 ここから
            fBName = AdjustLength(fBName, 20)
            userName = AdjustLength(userName, 20)
            Dim clientInfo As String = comm.GetClientInfo(sessionId)
            clientInfo = AdjustLength(clientInfo, 20)
            '追加 V8.60.25.21 ここまで
            Dim aliveFlag As String
            Dim wk_watchAliveInterval As Integer = comm.GetWatchAliveInterval() '追加 V8.60.25.21
            '置換 V8.60.25.21 If WatchAliveInterval = 0 Then
            If wk_watchAliveInterval = 0 Then
                aliveFlag = "+"
            Else
                If comm.IsLocalFormBaseAlive(sessionId) Then
                    aliveFlag = "*"
                Else
                    aliveFlag = "-"
                End If
            End If
            '置換 V8.60.25.21 System.Console.WriteLine("{0}{1,3:D} {2,-30} {3,-30}", aliveFlag, sessionId, fBName, userName)
            System.Console.WriteLine("{0}{1,3:D} {2} {3} {4}", aliveFlag, sessionId, fBName, userName, clientInfo)
        End Sub 'ShowSession

        Private Shared PromptTimer As System.Timers.Timer = New System.Timers.Timer(1000)

        Private Shared Sub PromptAfterOneSecond()
            SyncLock PromptTimer
                If Not PromptTimer.Enabled Then
                    AddHandler PromptTimer.Elapsed, AddressOf PromptTimerElapsed
                    PromptTimer.Start()
                End If
            End SyncLock
        End Sub 'PromptAfterOneSecond

        Private Shared Sub PromptTimerElapsed(ByVal sender As Object, ByVal ea As System.Timers.ElapsedEventArgs)
            PromptTimer.Stop()
            RemoveHandler PromptTimer.Elapsed, AddressOf PromptTimerElapsed
            PromptCommand()
        End Sub 'PromptTimerElapsed

        Private Shared Sub PromptCommand()
            System.Console.ForegroundColor = System.ConsoleColor.Yellow
            System.Console.WriteLine("コマンドを入力してください。(helpでコマンド一覧)")
            System.Console.Write(">")
            System.Console.ResetColor()
        End Sub 'PromptCommand

        Private Overloads Sub ShowMessage(ByVal msgColor As System.ConsoleColor, ByVal message As String, ByVal ParamArray param As Object())
            System.Console.ForegroundColor = System.ConsoleColor.White
            System.Console.WriteLine(message, param)
            System.Console.ResetColor()
        End Sub 'ShowMessage

        Private Overloads Sub ShowMessage(ByVal message As String, ByVal ParamArray param As Object())
            ShowMessage(System.ConsoleColor.White, message, param)
        End Sub 'ShowMessage

        Private Sub ShowInputError(ByVal message As String, ByVal ParamArray param As Object())
            System.Console.ForegroundColor = System.ConsoleColor.Red
            System.Console.WriteLine(message, param)
            System.Console.ResetColor()
        End Sub 'ShowInputError

        Private Sub ListHeader()
            System.Console.ForegroundColor = System.ConsoleColor.Green
            '置換 V8.60.25.21 System.Console.WriteLine(" {0,3} {1,-30} {2,-30}", "SID", "Form Name", "User Name")
            System.Console.WriteLine(" {0,3} {1,-20} {2,-20} {3,-20}", "SID", "Form Name", "User Name", "Extension")
            System.Console.ResetColor()
        End Sub 'ListHeader

        Private Shared ShiftJisEncoding As System.Text.Encoding = System.Text.Encoding.GetEncoding(932)

        Public Shared Function AdjustLength(ByVal pm_text As String, ByVal pm_length As Integer) As String
            If pm_text Is Nothing Then
                Return New String(" "c, pm_length)
            End If
            Dim strCount As Integer = 0
            Dim byteCount As Integer = 0
            While strCount < pm_text.Length
                Dim bytes As Byte() = ShiftJisEncoding.GetBytes(New Char() {pm_text.Chars(strCount)})
                If byteCount + bytes.Length > pm_length Then
                    Exit While
                End If
                byteCount += bytes.Length
                strCount += 1
            End While
            If byteCount >= pm_length Then
                Return pm_text.Substring(0, strCount) '------
            Else
                Return pm_text + New String(" "c, pm_length - byteCount) '------
            End If
        End Function 'AdjustLength

        '追加 V8.60.25.21ここまで

    End Class 'CentralMain
End Namespace 'CentralMain

