﻿Option Strict On
Option Explicit On
'☆ このソースコードの解読は､ 許諾されています。
Imports AppliTech.WorkFrame
Imports VB = Microsoft.VisualBasic
#If LocalOrOp OrElse Not CentralOrOp Then
Imports System.Windows.Forms
#End If

Friend Class 発注元コード

    'データ項目部品 ｢発注元コード｣

    'セントラルとローカル間､ および複数のフックメソッド間の連絡域
    Friend Interface Common
#If CentralOrOp OrElse Not LocalOrOp Then
        Property 発注元レコード() As 発注元Table '★ 親クラスの型にはしない。
#End If
    End Interface 'Common

    '#Region "ローカルピース､ セントラルピース共通に用いるフックメソッドなど"
    '    'なし
    '#End Region 'ローカルピース､ セントラルピース共通に用いるフックメソッドなど

#Region "ローカルピースに配置するフックメソッドなど"
#If LocalOrOp OrElse Not CentralOrOp Then

    '発注元コードの入力候補一覧を表示する。
    Friend Function 選択リスト(ByVal fB As FormBase, ByVal iB_発注元コード As ItemBase) As String
        Dim 発注元コード選択リスト As Jutyu.AppliFrame.SListBases.SListBase12 = New Dlg発注元コード(fB, iB_発注元コード)
        '
        Dim wk_DialogResult As DialogResult = 発注元コード選択リスト.ShowDialog(fB.myForm)
        If Not (fB.sListCom Is Nothing) Then
            Return CType(fB.sListCom, String) '----------
        Else
            Return Nothing '----------
        End If
    End Function '選択リスト

    'エラーメッセージを表示する (Response)。
    Friend Function 応答表示(ByVal fB As FormBase, ByVal Cd_Error As Integer) As Boolean
        If Cd_Error <> 0 Then
            Dim メッセージ As String
            Select Case Cd_Error
                Case 200
                    メッセージ = "発注元コードに誤りがあります。"
                Case Else
                    メッセージ = "登録されていないメッセージ " + Cd_Error.ToString() + " です。"
            End Select
            fB.Beep()
            fB.StatusOut(メッセージ, System.Drawing.Color.Red)
        End If
        Return True
    End Function '応答表示

#End If
#End Region 'ローカルピースに配置するフックメソッドなど

#Region "セントラルピースに配置するフックメソッドなど"
#If CentralOrOp OrElse Not LocalOrOp Then

    '◆ Jutyu0, Jutyu1 と異なり､ Jutyu2 では､ SList のデータをセントラルとローカル間で転送するように変更しました。
    Friend Function 中央局処理(ByVal fB As FormBase, ByVal Rm_Object As Object) As Object
        Select Case CType(Rm_Object, String)
            Case "ForSList"
                Dim co As Common = CType(fB.getCommon(), Common)
                Dim HatmtCdObj As Serializables.HatmtCd = New Serializables.HatmtCd(co.発注元レコード.RecordCount)
                '
                co.発注元レコード.SetCursorForAllRecords()
                Dim wk_Return As Integer = co.発注元レコード.ReadSequential()
                Dim I As Integer = 0
                While wk_Return = 0
                    HatmtCdObj.発注元コード(I) = co.発注元レコード.発注元コード
                    HatmtCdObj.発注元名称(I) = co.発注元レコード.発注元名称
                    HatmtCdObj.発注元種別(I) = co.発注元レコード.発注元種別
                    wk_Return = co.発注元レコード.ReadSequential()
                    I += 1
                End While
                '
                Return HatmtCdObj '----------
            Case Else
                Return Nothing '----------
        End Select
    End Function

    '発注元マスタテーブルをオープンする。
    Friend Function 開設現地後(ByVal fB As FormBase) As Boolean
        Dim co As Common = CType(fB.getCommon(), Common)
        Dim Path As String = FormBase.GetAppSetting("Jutyu2.DataDirectory")
        If Path Is Nothing Then Path = fB.MyBinPath
        co.発注元レコード = New 発注元Table(Path + "Hatmt.txt") '[20080825][追加] 
        '
        Dim 復帰コード As Integer = co.発注元レコード.Connect()
        Return ItemBase.BEGINPRGALCL_Allow '----------
    End Function '開設現地後

    '発注元コードが入力された場合に、そのチェックを行う。
    Friend Function 入力チェック(ByVal fB As FormBase, ByVal 発注元コード As String) As Integer
        If 発注元コード = String.Empty Then
            Return 200 '---------- 'エラーコード 200。
        Else
            Dim co As Common = CType(fB.getCommon(), Common)
            Dim 復帰コード As Integer = co.発注元レコード.SelectEqual(発注元コード)
            If 復帰コード = 0 Then 'コード項目が見つかった。
                Return ItemBase.CHECK_OK '---------- '正常終了。
            Else
                Return 200 '---------- 'エラーコード 200。
            End If
        End If
    End Function '入力チェック

    '発注元マスタテーブルをクローズする。
    Friend Function 閉鎖現地前(ByVal fB As FormBase) As Boolean
        Dim co As Common = CType(fB.getCommon(), Common)
        co.発注元レコード.Disconnect()
        Return ItemBase.CLOSEBLCL_Allow '----------
    End Function '閉鎖現地前

#End If
#End Region 'セントラルピースに配置するフックメソッドなど

End Class '発注元コード