﻿Option Strict On
Option Explicit On
'☆ このソースコードの解読は､ 許諾されています。
Imports AppliTech.WorkFrame
Imports VB = Microsoft.VisualBasic
#If LocalOrOp OrElse Not CentralOrOp Then
Imports System.Windows.Forms
#End If

Friend Class 受注コード

    'データ項目部品 ｢受注コード｣

    'セントラルとローカル間､ および複数のフックメソッド間の連絡域
    Friend Interface Common
#If CentralOrOp OrElse Not LocalOrOp Then
        WriteOnly Property 画面データキー() As String
        WriteOnly Property 画面キー項目フォーマット() As String
        ReadOnly Property 受注レコード() As 受注Table '★ 親クラスの型にはしない。
#End If
    End Interface 'Common

    '#Region "ローカルピース､ セントラルピース共通に用いるフックメソッドなど"
    '    'なし
    '#End Region 'ローカルピース､ セントラルピース共通に用いるフックメソッドなど

#Region "ローカルピースに配置するフックメソッドなど"
#If LocalOrOp OrElse Not CentralOrOp Then

    Private 手動カーソル移動 As Boolean '手動カーソル移動のフラグ。

    'Cancel 時に手動カーソル移動をクリア
    Friend Function 前処理(ByVal fB As FormBase) As Boolean
        If fB.Mode = FormBase.MODE_Append Then
            手動カーソル移動 = False
        End If
        Return True
    End Function '前処理

    '最初はカーソルを留めない。
    Friend Function スキップ(ByVal fB As FormBase) As Boolean
        If 手動カーソル移動 Then
            Return ItemBase.SKIP_False '---------- 'カーソルを留める。
        Else
            fB.CursorDirection = 1
            手動カーソル移動 = True '以後カーソルを留めることを可能にする。
            Return ItemBase.SKIP_True '---------- '最初はカーソルを留めない。
        End If
    End Function 'スキップ

    '受注コードの入力候補一覧を表示する。
    Friend Function 選択リスト(ByVal fB As FormBase, ByVal iB_受注コード As ItemBase) As String
        Dim 選択ダイアログ As Jutyu.AppliFrame.SListBases.SListBase12 = New Dlg受注コード(fB, iB_受注コード)
        '
        Dim wk_DialogResult As DialogResult = 選択ダイアログ.ShowDialog(fB.myForm)
        If Not (fB.sListCom Is Nothing) Then
            Return CType(fB.sListCom, String) '----------
        Else
            Return Nothing '----------
        End If
    End Function '選択リスト

    'エラーメッセージを表示する (Response)。
    Friend Function 応答表示(ByVal fB As FormBase, ByVal Cd_Error As Integer) As Boolean
        If Cd_Error <> 0 Then
            Dim メッセージ As String
            Select Case Cd_Error
                Case 600
                    メッセージ = "受注コードに誤りがあります。"
                Case 601
                    メッセージ = "動作モードの変更がキャンセルされました。"
                Case Else
                    メッセージ = "登録されていないメッセージ " + Cd_Error.ToString() + " です。"
            End Select
            fB.Beep()
            fB.StatusOut(メッセージ, System.Drawing.Color.Red)
        End If
        Return True
    End Function '応答表示

#End If
#End Region 'ローカルピースに配置するフックメソッドなど

#Region "セントラルピースに配置するフックメソッドなど"
#If CentralOrOp OrElse Not LocalOrOp Then

    Private 受注コード原本 As Integer = 0 '受注コードの初期値。

    '受注コードの初期値を設定する。
    Friend Function 初期値(ByVal fB As FormBase, ByVal 受注コード As String, ByVal iB_受注コード As ItemBase) As String
        Dim co As Common = CType(fB.getCommon(), Common)
        If fB.Mode = FormBase.MODE_Append Then
            If 受注コード原本 = 0 Then
                co.受注レコード.SelectLast()
                受注コード原本 = CInt(VB.Val(co.受注レコード.受注コード) + 1)
            End If
            co.画面データキー = VB.Strings.Format(受注コード原本.ToString(), iB_受注コード.FormatChr)
            Return VB.Strings.Format(受注コード原本.ToString(), iB_受注コード.FormatChr) '----------
        ElseIf fB.Mode = FormBase.MODE_Select Then
            co.画面データキー = VB.Strings.Format((受注コード原本 - 1).ToString(), iB_受注コード.FormatChr)
            Return VB.Strings.Format(受注コード原本.ToString(), iB_受注コード.FormatChr) '----------
        ElseIf 受注コード = String.Empty Then
            Return String.Empty '----------
        Else
            Return 受注コード '----------
        End If
    End Function '初期値

    '受注トランザクションテーブルをオープンする。
    Friend Function 開設現地後(ByVal fB As FormBase, ByVal iB_受注コード As ItemBase) As Boolean
        '受注トランザクションテーブルに関する処理は､ 受注業務画面部品で行なわれる。
        '
        Dim co As Common = CType(fB.getCommon(), Common)
        co.画面キー項目フォーマット = iB_受注コード.FormatChr
        '
        Return ItemBase.BEGINPRGALCL_Allow '----------
    End Function '開設現地後

    '受注コードが入力された場合に、そのチェックを行う。
    Friend Function 入力チェック(ByVal fB As FormBase, ByRef 受注コード As String, ByVal 前_受注コード As String, ByVal iB_受注コード As ItemBase) As Integer
        Dim co As Common = CType(fB.getCommon(), Common)
        If 受注コード = String.Empty Then
            If fB.Mode <> FormBase.MODE_Append Then
                受注コード = VB.Strings.Format(受注コード原本.ToString(), iB_受注コード.FormatChr)
                If fB.ChOprtLater(1) = True Then '1: Append モードにする。
                    Return ItemBase.CHECK_OK '---------- '正常終了。
                Else
                    Return 601 '---------- 'エラーコード 601。
                End If
            End If
        ElseIf 受注コード = VB.Strings.Format(受注コード原本.ToString(), iB_受注コード.FormatChr) Then
            '初期値と等しければ追加モードに戻す。
            If fB.Mode <> 1 Then
                If fB.ChOprtLater(1) = True Then '1: Append モードにする。
                    Return ItemBase.CHECK_OK '---------- '正常終了。
                Else
                    Return 601 '---------- 'エラーコード 601。
                End If
            End If
        ElseIf fB.Mode = FormBase.MODE_Append Then
            Dim 復帰コード As Integer = co.受注レコード.SelectEqual(受注コード)
            If 復帰コード = 10 Then '受注コードが見つからない。
                Return 600 '---------- 'エラーコード 600。
            ElseIf 復帰コード = 0 Then '受注コードが見つかった。
                If fB.ChOprtLater(3) = True Then '3: Indicate モードにする。
                    co.画面データキー = 受注コード
                    Return ItemBase.CHECK_OK '---------- '正常終了。
                Else
                    受注コード = 前_受注コード
                    Return 601 '---------- 'エラーコード 601。
                End If
            End If
        ElseIf fB.Mode = FormBase.MODE_Select Then
            Dim 復帰コード As Integer = co.受注レコード.SelectEqual(受注コード)
            If 復帰コード = 10 Then '受注コードが見つからない。
                Return 600 '---------- 'エラーコード 600。
            ElseIf 復帰コード = 0 Then '受注コードが見つかった。
                co.画面データキー = 受注コード
                Return ItemBase.CHECK_OK '---------- '正常終了。
            End If
        End If
        Return ItemBase.CHECK_OK '---------- '正常終了。
    End Function '入力チェック

    '受注トランザクションテーブルをクローズする。
    Friend Function 閉鎖現地前(ByVal fB As FormBase) As Boolean
        '受注トランザクションテーブルに関する処理は､ 受注業務画面部品で行なわれる。
        Return ItemBase.CLOSEBLCL_Allow '----------
    End Function '閉鎖現地前

    '伝票の書き出しの後に，受注コードをカウントアップする。
    Friend Function 後処理(ByVal fB As FormBase, ByVal 受注コード As String, ByVal iB_受注コード As ItemBase) As String
        If fB.Mode = FormBase.MODE_Append Then
            受注コード原本 = 受注コード原本 + 1
        ElseIf fB.Mode = FormBase.MODE_Update Then
            fB.StatusOut("伝票を更新しました。(受注コード " + VB.Strings.Format(受注コード, iB_受注コード.FormatChr) + ")", System.Drawing.Color.Blue)
        End If
        Return VB.Strings.Format(受注コード原本.ToString(), iB_受注コード.FormatChr) '----------
    End Function '後処理

#End If
#End Region 'セントラルピースに配置するフックメソッドなど

End Class '受注コード
