﻿Option Strict On
Option Explicit On
'☆ このソースコードの解読は､ 許諾されています。
Imports AppliTech.WorkFrame
Imports VB = Microsoft.VisualBasic

Friend Class 受注金額

    'データ項目部品 ｢受注金額｣

#Region "ローカルピース､ セントラルピース共通に用いるフックメソッドなど"

    '受注金額を計算して表示する。
    Friend Function 派生値双方(ByVal fB As FormBase, ByVal 受注個数 As WrpDecimal, ByVal 商品単価 As WrpDecimal, ByVal 受注金額 As WrpDecimal, ByVal 商品コード As String, ByVal 前_商品コード As String) As WrpDecimal
        If 商品コード = String.Empty Then
            Return Nothing '----------
        ElseIf 前_商品コード <> 商品コード AndAlso 受注個数 Is Nothing Then
            Return Nothing '----------
        ElseIf 商品単価 Is Nothing Then
            Return Nothing '----------
        ElseIf 受注個数 Is Nothing Then
            Return 受注金額 '----------
        Else
            Return New WrpDecimal(受注個数.DecimalV * 商品単価.DecimalV) '----------
        End If
    End Function '派生値双方

#End Region 'ローカルピース､ セントラルピース共通に用いるフックメソッドなど

#Region "ローカルピースに配置するフックメソッドなど"
#If LocalOrOp OrElse Not CentralOrOp Then

    '受注個数が空欄の場合だけカーソルを留める。
    Friend Function スキップ(ByVal fB As FormBase, ByVal 商品コード As String, ByVal 受注個数 As WrpDecimal, ByVal 詳_受注金額 As ItemBase, ByVal 識_受注金額 As Integer) As Boolean
        If 商品コード = String.Empty Then
            Return ItemBase.SKIP_True '----------
        ElseIf 受注個数 Is Nothing Then
            Return ItemBase.SKIP_False '----------
        Else
            'If fB.CursorDirection = 4 Then fB.CursorDirection = 2 '1: Next, 2: Prev, 3:Down, 4:Up
            Return ItemBase.SKIP_True '----------
        End If
    End Function 'スキップ

    'エラーメッセージを表示する (Response)。
    Friend Function 応答表示(ByVal fB As FormBase, ByVal Cd_Error As Integer) As Boolean
        If Cd_Error <> 0 Then
            Dim メッセージ As String
            Select Case Cd_Error
                Case 400
                    メッセージ = "１以上の数にしてください。"
                Case 402
                    メッセージ = "10,000,000,000 より小さい数にしてください。"
                Case Else
                    メッセージ = "登録されていないメッセージ " + Cd_Error.ToString() + " です。"
            End Select
            fB.Beep()
            fB.StatusOut(メッセージ, System.Drawing.Color.Red)
        End If
        Return True
    End Function '応答表示

#End If
#End Region 'ローカルピースに配置するフックメソッドなど

#Region "セントラルピースに配置するフックメソッドなど"
#If CentralOrOp OrElse Not LocalOrOp Then

    '受注金額が入力された場合に、そのチェックを行う。
    Friend Function 入力チェック(ByVal 受注金額 As WrpDecimal) As Integer
        If 受注金額 Is Nothing Then
            Return 400 '---------- 'エラーコード 400。
        ElseIf 受注金額.DecimalV = 0 Then
            Return 400 '---------- 'エラーコード 400。
        ElseIf 受注金額.DecimalV >= 10000000000.0# Then
            Return 402 '---------- 'エラーコード 402。
        Else
            Return ItemBase.CHECK_OK '---------- '正常終了。
        End If
    End Function '入力チェック

#End If
#End Region 'セントラルピースに配置するフックメソッドなど

End Class '受注金額
