﻿Option Strict On
Option Explicit On
'☆ このソースコードの解読は､ 許諾されています。
'Imports 受注業務.受注業務FormBase '(ii_xxxx 参照用)
Imports AppliTech.WorkFrame
Imports System
Imports System.Diagnostics
Imports VB = Microsoft.VisualBasic
#If LocalOrOp OrElse Not CentralOrOp Then
Imports System.Windows.Forms
#End If
#If CentralOrOp OrElse Not LocalOrOp Then
Imports Jutyu.AppliFrame.DBMS
#End If

Friend Class 受注業務

    '画面部品 ｢受注業務｣

    'セントラルとローカル間､ および複数のフックメソッド間の連絡域
    Friend Interface Common
        Property 画面データキー() As String
#If LocalOrOp OrElse Not CentralOrOp Then
        WriteOnly Property 有効日付() As Date
        Property 追加モードに移行直後() As Boolean
#End If
#If CentralOrOp OrElse Not LocalOrOp Then
        ReadOnly Property 画面キー項目フォーマット() As String
        Property 受注レコード() As 受注Table '★ 親クラスの型にはしない。
        Property 受注明細レコード() As 受注明細Table '★ 親クラスの型        
        ReadOnly Property 発注元レコード() As 発注元Table '★ 親クラスの型にはしない。
        '削除 ReadOnly Property 商品レコード() As 商品Table '★ 親クラスの型にはしない。
#End If
    End Interface 'Common

#Region "ローカルピース､ セントラルピース共通に用いるフックメソッドなど"

    Private fB As FormBase

#End Region 'ローカルピース､ セントラルピース共通に用いるフックメソッドなど

#Region "ローカルピースに配置するフックメソッドなど"
#If LocalOrOp OrElse Not CentralOrOp Then

    Private Declare Function WinHelp Lib "user32" Alias "WinHelpA" (ByVal hwnd As Integer, ByVal lpHelpFile As String, ByVal wCommand As Integer, ByVal dwData As Integer) As Integer

    Private ReadOnly 有効日付定数 As DateTime = New DateTime(1994, 8, 31)

    '受注業務プログラムの実行開始時の処理を行う (BeginPrg)。
    Friend Function 実行開始処理(ByVal fB As FormBase) As Boolean
#If DEBUG Then
        Debug.WriteLine("FormHook: 受注業務_BeginPrg")
        fB.DebugFormHook = True
        fB.DebugItemHook = True
        fB.ShowTransferDataSize = True
#End If
        '
        Me.fB = fB
        '
        Dim co As Common = CType(fB.getCommon(), Common)
        co.有効日付 = 有効日付定数
        '
        fB.BackColors(1) = System.Drawing.ColorTranslator.FromOle(&HFFFFC0) '淡い青
        Dim wk_Px As Integer = fB.BodyPx
        While wk_Px < fB.EBodyPx
            If ((wk_Px - fB.BodyPx) \ fB.BodyV) Mod 2 = 1 Then '明細インデックスが奇数のもの
                fB.SetCLs(wk_Px, 1)
            End If
            wk_Px += 1
        End While
        '
        Return FormBase.BEGINPRG_Allow '----------
    End Function '実行開始処理

    'ローカル側のクローズ処理 (Close)。
    Friend Function 閉鎖(ByVal fB As FormBase) As Integer
        Return FormBase.CLOSE_Allow '----------
    End Function '閉鎖

    'WINHELP を呼び出して指定のトピックに関するヘルプを表示する。
    Friend Function WINHELP_GetEvent(ByVal fB As FormBase) As Boolean
        Dim sg_Path As String = System.Reflection.Assembly.GetExecutingAssembly().Location
        sg_Path = Left(sg_Path, InStr(sg_Path, "\Jutyu2\bin")) + "Jutyu.html"
        Dim wk_process As System.Diagnostics.Process = System.Diagnostics.Process.Start(sg_Path)
        Return FormBase.GETEVENT_Allow '----------
    End Function 'WINHELP_GetEvent

    '追加モードへの移行の際のチェックを行う (AppendChk)。
    Friend Function 追加モード(ByVal fB As FormBase) As Boolean
        If Not CType(fB.myForm, Fr_受注業務).BackColor.Equals(System.Drawing.Color.WhiteSmoke) Then
            CType(fB.myForm, Fr_受注業務).BackColor = System.Drawing.Color.WhiteSmoke
            CType(fB.myForm, Fr_受注業務).Refresh()
        End If
        Dim co As Common = CType(fB.getCommon(), Common)
        co.追加モードに移行直後 = True
        '
        Return FormBase.APPENDCHK_Allow '----------
    End Function '追加モード

    '処理対象のデータを選択する (Select)。
    Friend Function 選択モード(ByVal fB As FormBase, ByVal iB_受注コード As ItemBase) As Integer
        Dim 選択ダイアログ As Jutyu.AppliFrame.SListBases.SListBase12 = New Dlg受注コード(fB, iB_受注コード)
        '
        Dim wk_DialogResult As DialogResult = 選択ダイアログ.ShowDialog(fB.myForm)
        If Not (fB.sListCom Is Nothing) Then
            Dim 選択値 As Object = fB.sListCom
            fB.sListCom = Nothing
            Dim co As Common = CType(fB.getCommon(), Common)
            co.画面データキー = CType(選択値, String)
            Return FormBase.SELECT_AppType '---------- '2: 表示または更新モードにせよという指定。
        Else
            Return FormBase.SELECT_Deny '---------- '0: モード変更不可の指定。
        End If
    End Function '選択モード

    '表示モードへの移行の際のチェックを行う (Indicate)。
    Friend Function 表示モード(ByVal fB As FormBase) As Boolean
        Dim co As Common = CType(fB.getCommon(), Common)
        If fB.Mode = FormBase.MODE_Append AndAlso co.画面データキー = String.Empty Then
            Return FormBase.INDICATE_Deny '----------
        Else
            If Not CType(fB.myForm, Fr_受注業務).BackColor.Equals(System.Drawing.ColorTranslator.FromOle(&HC0FFFF)) Then
                CType(fB.myForm, Fr_受注業務).BackColor = System.Drawing.ColorTranslator.FromOle(&HC0FFFF)
                CType(fB.myForm, Fr_受注業務).Refresh()
            End If
            '
            Return FormBase.INDICATE_Allow '----------
        End If
    End Function '表示モード

    '更新モードへの移行の際のチェックを行う (UpdateChk)。
    Friend Function 更新モード() As Boolean
        If Not CType(fB.myForm, Fr_受注業務).BackColor.Equals(System.Drawing.ColorTranslator.FromOle(&HFFC0C0)) Then
            CType(fB.myForm, Fr_受注業務).BackColor = System.Drawing.ColorTranslator.FromOle(&HFFC0C0)
            CType(fB.myForm, Fr_受注業務).Refresh()
        End If
        '
        Return FormBase.UPDATECHK_Allow '----------
    End Function '更新モード

#End If
#End Region 'ローカルピースに配置するフックメソッドなど

#Region "セントラルピースに配置するフックメソッドなど"
#If CentralOrOp OrElse Not LocalOrOp Then

    Private メインレコード As TextDBMS '★ 親クラスの型を指定している点にご注目いただきたい
    Private 明細レコード As TextDBMS '★ 親クラスの型を指定している点にご注目いただきたい

    '◆ Jutyu0, Jutyu1 と異なり､ Jutyu2 では､ SList のデータをセントラルとローカル間で転送するように変更しました。
    Friend Function 中央局処理(ByVal fB As FormBase, ByVal Rm_Object As Object) As Object
        Select Case CType(Rm_Object, String)
            Case "ForSList"
                Dim co As Common = CType(fB.getCommon(), Common)
                Dim JutyuCdObj As Serializables.JutyuCd = New Serializables.JutyuCd(メインレコード.RecordCount)
                '
                co.受注レコード.SetCursorForAllRecords()
                Dim wk_Return As Integer = co.受注レコード.ReadSequential()
                Dim I As Integer = 0
                While wk_Return = 0
                    Dim 復帰コード As Integer = co.発注元レコード.SelectEqual(co.受注レコード.発注元コード)
                    If 復帰コード <> 0 Then co.発注元レコード.発注元名称 = "(不明)" + VB.Strings.Space(18)
                    JutyuCdObj.受注コード(I) = co.受注レコード.受注コード
                    JutyuCdObj.受注日付(I) = co.受注レコード.受注日付
                    JutyuCdObj.発注元名称(I) = co.発注元レコード.発注元名称
                    wk_Return = co.受注レコード.ReadSequential()
                    I += 1
                End While
                '
                Return JutyuCdObj '----------
            Case Else
                Return Nothing '----------
        End Select
    End Function

    '受注トランザクションテーブルに現画面に関するレコードの追加 (書き出し) を行う (Append)。
    Friend Function 追加処理(ByVal fB As FormBase) As Integer
        TextDBMS.TranStart()
        '伝票の挿入処理を行う。
        FromHdTlToDB(fB)
        メインレコード.InsertRecord()
        '
        Dim 明細インデックス As Integer = 0
        While 明細インデックス < fB.LastDe
            FromBdToDB(fB, 明細インデックス)
            明細レコード.InsertRecord() '(画面データキー + TextDBMS.AlignRight((明細インデックス + 1).ToString(), 3))
            明細インデックス = 明細インデックス + 1
        End While
        '
        TextDBMS.TranCommit()
        '
        Dim co As Common = CType(fB.getCommon(), Common)
        fB.StatusOut("伝票を発行しました。(伝票番号 " + VB.Strings.Format(co.画面データキー, co.画面キー項目フォーマット) + ")", System.Drawing.Color.Blue)
        '
        '追加モードのまま、次のデータエントリを受け付ける。
        Return FormBase.APPEND_Append '---------- 
    End Function '追加処理

    '受注業務プログラムの実行開始時の処理を行う (BeginPrgAlcl)。
    Friend Function 実行開始処理現地後(ByVal fB As FormBase) As Boolean
#If DEBUG Then
        Debug.WriteLine("FormHook: 受注業務_BeginPrgAlcl")
        fB.DebugFormHook = True
        fB.DebugItemHook = True
        fB.ShowTransferDataSize = True
#End If
        '
        Me.fB = fB
        '
        Return FormBase.BEGINPRGALCL_Allow '----------
    End Function '実行開始処理現地後

    '処理対象のデータの中から現画面に関するレコードを再度読み込む (Current)。
    Friend Function 現画面(ByVal fB As FormBase) As Integer
        Dim co As Common = CType(fB.getCommon(), Common)
        If co.画面データキー = String.Empty Then
            Return FormBase.CURRENT_NoData '----------
        Else
            メインレコード.SelectEqual(co.画面データキー)
            FromDBToHdTl(fB)
            Dim 明細個数 As Integer = Integer.Parse(co.受注レコード.明細数)
            '
            Dim 明細インデックス As Integer = 0
            While 明細インデックス < 明細個数
                明細レコード.SelectEqual(co.画面データキー + TextDBMS.AlignRight((明細インデックス + 1).ToString(), 3))
                FromDBToBd(fB, 明細インデックス)
                明細インデックス += 1
            End While
            '
            Return 明細インデックス '----------
        End If
    End Function '現画面

    '受注トランザクションテーブルから現画面に関するレコードを削除する (Delete)。
    Friend Function 削除処理(ByVal fB As FormBase) As Integer
        TextDBMS.TranStart()
        '
        Dim co As Common = CType(fB.getCommon(), Common)
        Dim 明細個数 As Integer = Integer.Parse(co.受注レコード.明細数)
        Dim 明細インデックス As Integer = 0
        While 明細インデックス < 明細個数
            明細レコード.DeleteRecord(co.画面データキー + TextDBMS.AlignRight((明細インデックス + 1).ToString(), 3))
            明細インデックス += 1
        End While
        '
        メインレコード.DeleteRecord(co.画面データキー)
        '
        TextDBMS.TranCommit()
        '
        fB.StatusOut("伝票を削除しました。(伝票番号 " + VB.Strings.Format(co.画面データキー, co.画面キー項目フォーマット) + ")", System.Drawing.Color.Black)
        '
        Return FormBase.DELETE_AppType '---------- '1: 選択モード。 2: 次をオマカセ。 3: 次を表示。 4: 次を更新。 その他: 追加モードへ。
    End Function '削除処理

    '処理対象のデータの中から先頭画面に関するレコードを読み込む (First)。
    Friend Function 先頭画面(ByVal fB As FormBase) As Integer
        If メインレコード.SelectFirst() = 0 Then
            FromDBToHdTl(fB)
            '
            Dim co As Common = CType(fB.getCommon(), Common)
            co.画面データキー = CType(メインレコード, 受注Table).受注コード
            Dim 明細個数 As Integer = Integer.Parse(co.受注レコード.明細数)
            '
            Dim 明細インデックス As Integer = 0
            While 明細インデックス < 明細個数
                明細レコード.SelectEqual(co.画面データキー + TextDBMS.AlignRight((明細インデックス + 1).ToString(), 3))
                FromDBToBd(fB, 明細インデックス)
                明細インデックス += 1
            End While
            '
            Return 明細インデックス '----------
        Else
            Return FormBase.FIRST_NoData '----------
        End If
    End Function '先頭画面

    '処理対象のデータの中から最終画面に関するレコードを読み込む (Last)。
    Friend Function 最終画面(ByVal fB As FormBase) As Integer
        If メインレコード.SelectLast() = 0 Then
            FromDBToHdTl(fB)
            '
            Dim co As Common = CType(fB.getCommon(), Common)
            co.画面データキー = CType(メインレコード, 受注Table).受注コード
            Dim 明細個数 As Integer = Integer.Parse(co.受注レコード.明細数)
            '
            Dim 明細インデックス As Integer = 0
            While 明細インデックス < 明細個数
                明細レコード.SelectEqual(co.画面データキー + TextDBMS.AlignRight((明細インデックス + 1).ToString(), 3))
                FromDBToBd(fB, 明細インデックス)
                明細インデックス += 1
            End While
            '
            Return 明細インデックス '----------
        Else
            Return FormBase.LAST_NoData '----------
        End If
    End Function '最終画面

    '処理対象のデータの中から現画面の次の画面に関するレコードを読み込む (Next)。
    Friend Function 次画面(ByVal fB As FormBase) As Integer
        Dim co As Common = CType(fB.getCommon(), Common)
        If co.画面データキー = String.Empty Then
            Return FormBase.NEXT_NoData '----------
        Else
            If メインレコード.SelectNext(co.画面データキー) = 0 Then
                FromDBToHdTl(fB)
                '
                co.画面データキー = CType(メインレコード, 受注Table).受注コード
                Dim 明細個数 As Integer = Integer.Parse(co.受注レコード.明細数)
                '
                Dim 明細インデックス As Integer = 0
                While 明細インデックス < 明細個数
                    明細レコード.SelectEqual(co.画面データキー + TextDBMS.AlignRight((明細インデックス + 1).ToString(), 3))
                    FromDBToBd(fB, 明細インデックス)
                    明細インデックス += 1
                End While
                '
                Return 明細インデックス '----------
            Else
                Return FormBase.NEXT_NoData '----------
            End If
        End If
    End Function '次画面

    '処理対象のデータの中から現画面の一つ前の画面に関するレコードを読み込む (Prev)。
    Friend Function 前画面(ByVal fB As FormBase) As Integer
        Dim co As Common = CType(fB.getCommon(), Common)
        If co.画面データキー = String.Empty Then
            Return FormBase.PREV_NoData '----------
        Else
            If メインレコード.SelectPrev(co.画面データキー) = 0 Then
                FromDBToHdTl(fB)
                '
                co.画面データキー = CType(メインレコード, 受注Table).受注コード
                Dim 明細個数 As Integer = Integer.Parse(co.受注レコード.明細数)
                '
                Dim 明細インデックス As Integer = 0
                While 明細インデックス < 明細個数
                    明細レコード.SelectEqual(co.画面データキー + TextDBMS.AlignRight((明細インデックス + 1).ToString(), 3))
                    FromDBToBd(fB, 明細インデックス)
                    明細インデックス += 1
                End While
                '
                Return 明細インデックス '----------
            Else
                Return FormBase.PREV_NoData '----------
            End If
        End If
    End Function '前画面

    Private Sub FromHdTlToDB(ByVal fB As FormBase)
        Dim co As Common = CType(fB.getCommon(), Common)
        co.受注レコード.受注コード = fB.getValue(ii_受注コード)
        co.受注レコード.受注日付 = FormBase.FormatDate(DateTime.Parse(fB.getValue(ii_受注日付)), "yyyy/MM/dd")
        co.受注レコード.発注元コード = fB.getValue(ii_発注元コード)
        co.受注レコード.明細数 = fB.LastDe.ToString()
        co.受注レコード.注釈 = fB.getValue(ii_注釈)
    End Sub 'FromHdTlToDB

    Private Sub FromBdToDB(ByVal fB As FormBase, ByVal 明細インデックス As Integer)
        Dim co As Common = CType(fB.getCommon(), Common)
        co.受注明細レコード.受注コード = fB.getValue(ii_受注コード)
        co.受注明細レコード.明細番号 = fB.getValue(ii_明細番号, 明細インデックス).toString()
        co.受注明細レコード.商品コード = fB.getValue(ii_商品コード, 明細インデックス)
        co.受注明細レコード.商品単価 = fB.getValue(ii_商品単価, 明細インデックス).toString()
        If fB.getValue(ii_受注個数, 明細インデックス) Is Nothing Then
            co.受注明細レコード.受注個数 = String.Empty
        Else
            co.受注明細レコード.受注個数 = fB.getValue(ii_受注個数, 明細インデックス).toString()
        End If
        co.受注明細レコード.受注金額 = fB.getValue(ii_受注金額, 明細インデックス).toString()
    End Sub 'FromBdToDB

    '受注トランザクションテーブルの現画面に関するレコードの更新を行う (Update)。
    Friend Function 更新処理(ByVal fB As FormBase) As Integer
        Dim co As Common = CType(fB.getCommon(), Common)
        TextDBMS.TranStart()
        '伝票の更新処理を行う。
        Dim 明細個数 As Integer = Integer.Parse(co.受注レコード.明細数)
        Dim 明細インデックス As Integer = 0
        While 明細インデックス < 明細個数
            明細レコード.DeleteRecord(co.画面データキー + TextDBMS.AlignRight((明細インデックス + 1).ToString(), 3))
            明細インデックス += 1
        End While
        '
        明細インデックス = 0
        While 明細インデックス < fB.LastDe
            FromBdToDB(fB, 明細インデックス)
            明細レコード.InsertRecord() '(画面データキー + TextDBMS.AlignRight((明細インデックス + 1).ToString(), 3))
            明細インデックス = 明細インデックス + 1
        End While
        '
        FromHdTlToDB(fB)
        メインレコード.UpdateRecord(co.画面データキー)
        '
        TextDBMS.TranCommit()
        '
        fB.StatusOut("伝票を更新しました。(伝票番号 " + VB.Strings.Format(co.画面データキー, co.画面キー項目フォーマット) + ")", System.Drawing.Color.Black)
        '
        '更新モードのまま、次の画面データを表示する。
        Return FormBase.UPDATE_Update '----------
    End Function '更新処理

    Private Sub FromDBToHdTl(ByVal fB As FormBase)
        Dim co As Common = CType(fB.getCommon(), Common)
        fB.setValue(ii_受注コード, co.受注レコード.受注コード)
        fB.setValue(ii_受注日付, co.受注レコード.受注日付)
        fB.setValue(ii_発注元コード, co.受注レコード.発注元コード)
        fB.setValue(ii_注釈, co.受注レコード.注釈)
    End Sub 'FromDBToHdTl

    Private Sub FromDBToBd(ByVal fB As FormBase, ByVal 明細インデックス As Integer)
        Dim co As Common = CType(fB.getCommon(), Common)
        fB.setValue(ii_商品コード, 明細インデックス, co.受注明細レコード.商品コード)
        If co.受注明細レコード.受注個数 Is Nothing OrElse co.受注明細レコード.受注個数.Trim().Length = 0 Then
            fB.setValue(ii_受注個数, 明細インデックス, Nothing)
        Else
            fB.setValue(ii_受注個数, 明細インデックス, New WrpDecimal(co.受注明細レコード.受注個数.Trim()))
        End If
        If co.受注明細レコード.商品単価 Is Nothing OrElse co.受注明細レコード.商品単価.Trim().Length = 0 Then
            fB.setValue(ii_商品単価, 明細インデックス, Nothing)
        Else
            fB.setValue(ii_商品単価, 明細インデックス, New WrpDecimal(co.受注明細レコード.商品単価.Trim()))
        End If
        If co.受注明細レコード.受注金額 Is Nothing OrElse co.受注明細レコード.受注金額.Trim().Length = 0 Then
            fB.setValue(ii_受注金額, 明細インデックス, Nothing)
        Else
            fB.setValue(ii_受注金額, 明細インデックス, New WrpDecimal(co.受注明細レコード.受注金額.Trim()))
        End If
        '削除 fB.setValue(ii_注釈, co.受注レコード.注釈)
    End Sub 'FromDBToBd

    '受注トランザクションテーブルをオープンする。
    Friend Function 開設現地後(ByVal fB As FormBase) As Boolean
        Dim co As Common = CType(fB.getCommon(), Common)
        Dim Path As String = FormBase.GetAppSetting("Jutyu2.DataDirectory")
        If Path Is Nothing Then Path = fB.MyBinPath
        メインレコード = New 受注Table(Path + "Jutyu.txt")
        co.受注レコード = CType(メインレコード, 受注Table)
        明細レコード = New 受注明細Table(Path + "JutyuDe.txt")
        co.受注明細レコード = CType(明細レコード, 受注明細Table)
        '
        Dim メイン復帰コード As Integer = メインレコード.Connect()
        Dim 明細復帰コード As Integer = 明細レコード.Connect()
        '
        Return FormBase.OPENALCL_Allow '----------
    End Function '開設現地後

    '受注トランザクションテーブルをクローズする。
    Friend Function 閉鎖現地前(ByVal fB As FormBase) As Boolean
        メインレコード.Disconnect()
        明細レコード.Disconnect()
        '
        Return FormBase.CLOSEBLCL_Allow '----------
    End Function '閉鎖現地前

#End If
#End Region 'セントラルピースに配置するフックメソッドなど

End Class '受注業務
